<template>
  <Dialog v-model="dialogVisible" :title="dialogTitle" width="450">
    <el-form
      ref="formRef"
      v-loading="formLoading"
      :model="formData"
      :rules="formRules"
      label-width="120px"
    >
      <el-form-item label="所属硬件" prop="hardwareId">
        <el-select
          v-model="formData.hardwareId"
          placeholder="请选择所属硬件"
          clearable
          class="!w-240px"
        >
          <el-option
            v-for="dict in hardwareOptions"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
<!--      <el-row>-->
<!--        <el-col :span="15">-->
<!--          <el-form-item label="钥匙编码" prop="keyCode">-->
<!--            <el-input-->
<!--              v-model="formData.keyCode"-->
<!--              placeholder="请输入钥匙编码"-->
<!--              class="!w-240px"-->
<!--            />-->
<!--          </el-form-item>-->
<!--        </el-col>-->
<!--        <el-col :span="8">-->
<!--          <el-form-item label-width="80">-->
<!--            <el-switch-->
<!--              v-model="autoGenFlag"-->
<!--              active-color="#13ce66"-->
<!--              active-text="自动生成"-->
<!--              @change="handleAutoGenChange"-->
<!--              v-if="formType !== 'view'"-->
<!--            />-->
<!--          </el-form-item>-->
<!--        </el-col>-->
<!--      </el-row>-->
      <el-form-item label="钥匙名称" prop="keyName">
        <el-input
          v-model="formData.keyName"
          placeholder="请输入钥匙名称"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="钥匙NFC" prop="keyNfc">
        <el-input
          v-model="formData.keyNfc"
          placeholder="请输入钥匙Nfc"
          maxlength="16"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="MAC地址" prop="macAddress">
        <el-input
          v-model="formData.macAddress"
          placeholder="请输入Mac地址"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="钥匙型号" prop="keySpec">
        <el-input
          v-model="formData.keySpec"
          placeholder="请输入钥匙型号"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="状态" prop="exStatus">
        <el-radio-group v-model="formData.exStatus">
          <el-radio
            v-for="dict in getStrDictOptions(DICT_TYPE.KEY_STATUS)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="备注" prop="exRemark">
        <el-input
          v-model="formData.exRemark"
          placeholder="请输入备注"
          class="!w-240px"
        />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button :disabled="formLoading" type="primary" @click="submitForm">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>

<script lang="ts" setup>
import { ref, reactive } from 'vue'
import { DICT_TYPE, getStrDictOptions } from '@/utils/dict'
import * as KeyApi from '@/api/hw/hardware/keys/index'
import * as HardwareApi from '@/api/hw/hardware/information/index'
// import * as AutocodeApi from '@/api/system/autocode/rule'

defineOptions({ name: 'KeyForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const autoGenFlag = ref(false) // 是否自动生成编码

const formData = ref({
  keyId: undefined,
  hardwareId: undefined,
  keyCode: '',
  keyName: '',
  keyNfc: '',
  macAddress: '',
  keySpec: '',
  exStatus: '1',
  exRemark: ''
})

const formRules = reactive({
  // keyCode: [{ required: true, message: '钥匙编码不能为空', trigger: 'blur' }],
  keyName: [{ required: true, message: '钥匙名称不能为空', trigger: 'blur' }],
  keyNfc: [{ required: true, message: '钥匙NFC不能为空', trigger: 'blur' }],
  macAddress: [{ required: true, message: 'MAC地址不能为空', trigger: 'blur' }]
})

const formRef = ref() // 表单 Ref
const hardwareOptions = ref([]) // 硬件选项

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await KeyApi.getKeyInfoAPI(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef.value) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value
    if (formType.value === 'create') {
      await KeyApi.addKeyAPI(data)
      message.success(t('common.createSuccess'))
    } else {
      await KeyApi.updateKeyAPI(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    keyId: undefined,
    hardwareId: undefined,
    keyCode: '',
    keyName: '',
    keyNfc: '',
    macAddress: '',
    keySpec: '',
    exStatus: '1',
    exRemark: ''
  }
  autoGenFlag.value = false
  formRef.value?.resetFields()
}

/** 自动生成编码 */
// const handleAutoGenChange = async (value: boolean) => {
//   if (value) {
//     formData.value.keyCode = await AutocodeApi.genCode('KEY_CODE')
//   } else {
//     formData.value.keyCode = ''
//   }
// }

/** 获取硬件列表 */
const getHardwareList = async () => {
  const data = { pageNo: 1, pageSize: -1 }
  const response = await HardwareApi.listHardware(data)
  hardwareOptions.value = response.list.map(item => ({
    value: item.id,
    label: item.hardwareName
  }))
}

/** 初始化 **/
onMounted(async () => {
  await getHardwareList()
})
</script>
